LootWhatIWant_panel = ""
LootWhatIWant_GlobalBlackList = { }
local LootWhatIWant_blacklist_placeholder = ""
LWIW_Options_ThresholdlDropDown_Menu_List = {
	{ name = "|cff1eff00Uncommon|r", number= "2" },
	{ name = "|cff0070ddRare|r", number= "3" },
	{ name = "|cffa335eeEpic|r", number= "4" },
};

function LWIW_GUI_OnLoad(panel)
	-- Panel to incorporate into blizz's built in frame
        panel.name = "LootWhatIWant-Options";
	LootWhatIWant_panel = panel
   
	
        InterfaceOptions_AddCategory(panel);
	
	LWIW_DeleteOption:SetChecked(LootWhatIWant.deleteItems)
	
end

function LWIW_Options_OnLoad(panel2)
	--local panel2 = "LWIW_DeleteOption"
	panel2.name = "LootWhatIWant-Blacklist";
	panel2.parent = "LootWhatIWant-Options";
	InterfaceOptions_AddCategory(panel2);
	
	
	StaticPopupDialogs["LWIW_DeleteItem"] = {
		text = "Do you really want to delete %s from your Black List?",
		button1 = "Yes",
		button2 = "No",
		OnAccept = function()
		      LWIW_Remove(LootWhatIWant.blacklistcount[(LootWhatIWant.blacklist_GUI_linenumber + FauxScrollFrame_GetOffset(LWIW_BlackList_ScrollBar))], LootWhatIWant.blacklist[LootWhatIWant.blacklistcount[(LootWhatIWant.blacklist_GUI_linenumber + FauxScrollFrame_GetOffset(LWIW_BlackList_ScrollBar))]])
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1,
	};
	StaticPopupDialogs["LWIW_DeleteBagItems"] = {
		text = "Do you really want to delete all items in your bags from your Black List?",
		button1 = "Yes",
		button2 = "No",
		OnAccept = function()
		      LWIW_ProcessDeletes()
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1,
	};
	StaticPopupDialogs["LWIW_ChangeGrayValue"] = {
		text = "Change Gray deletion options (0 no grays deleted, -1 all grays deleted, \n Delete all grays < [value] entered",
		button1 = "Ok",
		button2 = "Cancel",
		OnShow = function (self, data)
		    self.editBox:SetText(LootWhatIWant.deleteGrays)
		end,
		OnAccept = function (self, data, data2)
		    local ttext = self.editBox:GetText()
		    LWIW_SetDeleteGrays(ttext)
		end,
		hasEditBox = true,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1,
	};
	StaticPopupDialogs["LWIW_ChangeiLVLValue"] = {
		text = "Change iLVL sell options (Sell all BoP ilvl is < [value] entered",
		button1 = "Ok",
		button2 = "Cancel",
		OnShow = function (self, data)
		    self.editBox:SetText(LootWhatIWant.KeepBOPMaxiLVL)
		end,
		OnAccept = function (self, data, data2)
		    local ttext = self.editBox:GetText()
		    LWIW_SetiLVLSell(ttext)
		end,
		hasEditBox = true,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1,
	};
			
	LWIW_BlackList_ScrollBar:Show()
end

function LWIW_ProfileFrame_OnLoad(panel3)
	panel3.name = "LWIW-Profiles";
	panel3.parent = "LootWhatIWant-Options";
	InterfaceOptions_AddCategory(panel3);
	StaticPopupDialogs["LWIW_CopyBLToGlobal"] = {
		text = "Do you really want to copy your blacklist to the global list so your other toons can access?",
		button1 = "Yes",
		button2 = "No",
		OnAccept = function()
		      LWIW_TransferLocalBLtoGlobalBL()
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1,
	};
	StaticPopupDialogs["LWIW_CopyGlobalBLtoLocal"] = {
		text = "Do you really want to copy %s's blacklist to your own?",
		button1 = "Yes",
		button2 = "No",
		OnAccept = function()
		      LWIW_TransferGlobalBLtoLocalBL(UIDropDownMenu_GetSelectedName(LWIW_ProfileDown_Menu))
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1,
	};
	LWIW_ProfilesBlackList_ScrollBar:Show()
end

function LWIW_KeepFrame_OnLoad(panel4)
	panel4.name = "LWIW-KeepList";
	panel4.parent = "LootWhatIWant-Options";
	InterfaceOptions_AddCategory(panel4);
	StaticPopupDialogs["LWIW_KeepItem_Remove"] = {
		text = "Do you really want to delete %s from your Keep List?",
		button1 = "Yes",
		button2 = "No",
		OnAccept = function()
		      LWIW_KeepItem_Removal(LootWhatIWant.keepListcount[(LootWhatIWant.keepList_GUI_linenumber + FauxScrollFrame_GetOffset(LWIW_KeepList_ScrollBar))], LootWhatIWant.keepList[LootWhatIWant.keepListcount[(LootWhatIWant.keepList_GUI_linenumber + FauxScrollFrame_GetOffset(LWIW_KeepList_ScrollBar))]])
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1,
	};
	LWIW_KeepList_ScrollBar:Show()
end

function LWIW_SellFrame_OnLoad(panel5)
	panel5.name = "LWIW-SellList";
	panel5.parent = "LootWhatIWant-Options";
	InterfaceOptions_AddCategory(panel5);
	StaticPopupDialogs["LWIW_SellItem_Remove"] = {
		text = "Do you really want to delete %s from your Sell List?",
		button1 = "Yes",
		button2 = "No",
		OnAccept = function()
		      LWIW_SellItem_Removal(LootWhatIWant.sellListcount[(LootWhatIWant.sellList_GUI_linenumber + FauxScrollFrame_GetOffset(LWIW_SellList_ScrollBar))], LootWhatIWant.sellList[LootWhatIWant.sellListcount[(LootWhatIWant.sellList_GUI_linenumber + FauxScrollFrame_GetOffset(LWIW_SellList_ScrollBar))]])
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1,
	};
	LWIW_SellList_ScrollBar:Show()
end

function LWIW_ProfileDownMenu_OnLoad()
	
	if (LootWhatIWant_GlobalBlackList == nil or (#LootWhatIWant_GlobalBlackList == 0))then
		
		info            = {};
		info.text       = "Profiles";
		--info.value      = "OptionVariable";
		--info.func       = FunctionCalledWhenOptionIsClicked 
			 -- can also be done as function() FunctionCalledWhenOptionIsClicked() end;
	       
	       -- Add the above information to the options menu as a button.
		UIDropDownMenu_AddButton(info);
		UIDropDownMenu_SetSelectedName(LWIW_ProfileDown_Menu, "Profiles")
	else
		for i = 1, #LootWhatIWant_GlobalBlackList do
			info            = {};
			info.text       = LootWhatIWant_GlobalBlackList[i].playername;
			info.func     = LWIW_ProfileDownMenu_OnClick;
			UIDropDownMenu_AddButton(info);
		end
		
	end
end

function LWIW_ThresholdDownMenu_OnLoad()
	for i = 1, getn(LWIW_Options_ThresholdlDropDown_Menu_List), 1 do
		info = { };
		info.text = LWIW_Options_ThresholdlDropDown_Menu_List[i].name;
		info.func = LWIW_Options_ThresholdDropDown_Menu_OnClick;
		UIDropDownMenu_AddButton(info);
	end
	if (LootWhatIWant.lootRarity == nil) then
		LootWhatIWant.lootRarity = 2
	end
	UIDropDownMenu_SetSelectedID(LWIW_ThresholdDown_Menu, (LootWhatIWant.lootRarity - 1))
	UIDropDownMenu_SetSelectedName(LWIW_ThresholdDown_Menu, LWIW_Options_ThresholdlDropDown_Menu_List[(LootWhatIWant.lootRarity - 1)].name)
end

function LWIW_BlackListSB_Update()
	local line; -- 1 through 5 of our window to scroll
	local lineplusoffset; -- an index into our data calculated from the scroll offset
	local totallines
	if (#LootWhatIWant.blacklistcount < 22) then
		totallines = 22
	else
		totallines = #LootWhatIWant.blacklistcount
	end
	FauxScrollFrame_Update(LWIW_BlackList_ScrollBar,totallines,22,16);
	for line=1,22 do
		lineplusoffset = line + FauxScrollFrame_GetOffset(LWIW_BlackList_ScrollBar);
		if lineplusoffset <= #LootWhatIWant.blacklistcount then
			getglobal("LWIW_ButtonEntry_BlackList"..line):SetText(lineplusoffset..". "..LootWhatIWant.blacklist[LootWhatIWant.blacklistcount[lineplusoffset]]);
			getglobal("LWIW_ButtonEntry_BlackList"..line):Show();
		else
			getglobal("LWIW_ButtonEntry_BlackList"..line):Hide();
		end
	end
end

function LWIW_KeepListSB_Update()
	local line; -- 1 through 5 of our window to scroll
	local lineplusoffset; -- an index into our data calculated from the scroll offset
	local totallines
	if (LootWhatIWant.keepListcount == nil) then
		LootWhatIWant.keepListcount = { }
	end
	if (#LootWhatIWant.keepListcount < 22) then
		totallines = 22
	else
		totallines = #LootWhatIWant.keepListcount
	end
	
	FauxScrollFrame_Update(LWIW_KeepList_ScrollBar,totallines,22,16);
	for line=1,22 do
		lineplusoffset = line + FauxScrollFrame_GetOffset(LWIW_KeepList_ScrollBar);
		if lineplusoffset <= #LootWhatIWant.keepListcount then
			getglobal("LWIW_ButtonEntry_KeepList"..line):SetText(lineplusoffset..". "..LootWhatIWant.keepList[LootWhatIWant.keepListcount[lineplusoffset]]);
			getglobal("LWIW_ButtonEntry_KeepList"..line):Show();
		else
			getglobal("LWIW_ButtonEntry_KeepList"..line):Hide();
		end
	end
end

function LWIW_SellListSB_Update()
	local line; -- 1 through 5 of our window to scroll
	local lineplusoffset; -- an index into our data calculated from the scroll offset
	local totallines
	if (LootWhatIWant.sellListcount == nil) then
		LootWhatIWant.sellListcount = {}
	end
	if (#LootWhatIWant.sellListcount < 22) then
		totallines = 22
	else
		totallines = #LootWhatIWant.sellListcount
	end
	
	FauxScrollFrame_Update(LWIW_SellList_ScrollBar,totallines,22,16);
	for line=1,22 do
		lineplusoffset = line + FauxScrollFrame_GetOffset(LWIW_SellList_ScrollBar);
		if lineplusoffset <= #LootWhatIWant.sellListcount then
			getglobal("LWIW_ButtonEntry_SellList"..line):SetText(lineplusoffset..". "..LootWhatIWant.sellList[LootWhatIWant.sellListcount[lineplusoffset]]);
			getglobal("LWIW_ButtonEntry_SellList"..line):Show();
		else
			getglobal("LWIW_ButtonEntry_SellList"..line):Hide();
		end
	end
end

function LWIW_ProfileBlackListSB_Update()
	local line; -- 1 through 5 of our window to scroll
	local lineplusoffset; -- an index into our data calculated from the scroll offset
	local totallines
	
	local LWIW_ProfilesBlacklist_Placeholder = UIDropDownMenu_GetSelectedID(LWIW_ProfileDown_Menu)
	
	if (#LootWhatIWant_GlobalBlackList[LWIW_ProfilesBlacklist_Placeholder].blacklistcount < 22) then
		totallines = 22
	else
		totallines = #LootWhatIWant_GlobalBlackList[LWIW_ProfilesBlacklist_Placeholder].blacklistcount
	end
	FauxScrollFrame_Update(LWIW_ProfilesBlackList_ScrollBar,totallines,22,16);
	for line=1,22 do
		
		lineplusoffset = line + FauxScrollFrame_GetOffset(LWIW_ProfilesBlackList_ScrollBar);
		if lineplusoffset <= #LootWhatIWant_GlobalBlackList[LWIW_ProfilesBlacklist_Placeholder].blacklistcount then
			getglobal("LWIW_ProfilesButtonEntry_BlackList"..line):SetText(lineplusoffset..". "..LootWhatIWant_GlobalBlackList[LWIW_ProfilesBlacklist_Placeholder].blacklist[LootWhatIWant_GlobalBlackList[LWIW_ProfilesBlacklist_Placeholder].blacklistcount[lineplusoffset]]);
			getglobal("LWIW_ProfilesButtonEntry_BlackList"..line):Show();
		else
			getglobal("LWIW_ProfilesButtonEntry_BlackList"..line):Hide();
		end
	end
end

